ghc-7.0.3: The GHC API

TcMatches

# Documentation

tcMatchesFun :: Name -> Bool -> MatchGroup Name -> TcSigmaType -> TcM (HsWrapper, MatchGroup TcId)

tcGRHSsPat :: GRHSs Name -> TcRhoType -> TcM (GRHSs TcId)

tcMatchesCase :: TcMatchCtxt -> TcRhoType -> MatchGroup Name -> TcRhoType -> TcM (MatchGroup TcId)

tcMatchLambda :: MatchGroup Name -> TcRhoType -> TcM (HsWrapper, MatchGroup TcId)

data TcMatchCtxt

Constructors

MC |

Fields

mc_what :: HsMatchContext Name
mc_body :: LHsExpr Name -> TcRhoType -> TcM (LHsExpr TcId)

tcStmts :: HsStmtContext Name -> TcStmtChecker -> [LStmt Name] -> TcRhoType -> (TcRhoType -> TcM thing) -> TcM ([LStmt TcId], thing)

tcDoStmts :: HsStmtContext Name -> [LStmt Name] -> LHsExpr Name -> TcRhoType -> TcM (HsExpr TcId)

tcBody :: LHsExpr Name -> TcRhoType -> TcM (LHsExpr TcId)

tcDoStmt :: TcStmtChecker

tcMDoStmt :: (LHsExpr Name -> TcM (LHsExpr TcId, TcType)) -> TcStmtChecker

tcGuardStmt :: TcStmtChecker